# Complexité des algorithmes - TP
# ===============================

# Exercice 2
# ----------

import random
import time
import matplotlib.pyplot as plt
import copy

# ========================================================================================
# Création de 5 listes de taille incrémentale et de contenu aléatoire
nbElement = 150 # nb elem min (max = nbElement*25)
donneesRandom = []
donneesTriees = []
donneesInversees = []
axis = []
for i in range(1,6):
    jeudonneesRandom = []
    jeudonneesTriees = []
    jeudonneesInversees = []
    for j in range(nbElement*i*i):
        jeudonneesRandom.append(random.randint(0,10000))
        jeudonneesTriees.append(j)
        jeudonneesInversees.append(nbElement*i*i-1-j)
    donneesRandom.append(jeudonneesRandom)
    donneesTriees.append(jeudonneesTriees)
    donneesInversees.append(jeudonneesInversees)
    axis.append(nbElement*i*i)

def estTrie(l) :
    for i in range(len(l)-1):
        if l[i] > l[i+1] : return False
    return True

def sontTries(l):
    for i in range(len(l)):
        if not estTrie(l[i]) : return (False,i)
    return (True,0)

def executerTri(fct_tri,color,nom,surplace=True):
    toplotRandom = []
    toplotTriees = []
    toplotInversees = []
    donneesTestRandom = copy.deepcopy(donneesRandom)
    donneesTestTriees = copy.deepcopy(donneesTriees)
    donneesTestInversees = copy.deepcopy(donneesInversees)
    for i in range(len(donneesRandom)):
        time1 = time.time()
        if surplace:
            fct_tri(donneesTestRandom[i])
        else:
            donneesTestRandom[i] = fct_tri(donneesTestRandom[i])
        time2 = time.time()
        toplotRandom.append(time2 - time1)
        if nom != 'Tri rapide': # sinon maximum recursion depth exceeded in comparison
            time3 = time.time()
            if surplace:
                fct_tri(donneesTestTriees[i])
            else:
                donneesTestTriees[i] = fct_tri(donneesTestTriees[i])
            time4 = time.time()
            toplotTriees.append(time4 - time3)
            time5 = time.time()
            if surplace:
                fct_tri(donneesTestInversees[i])
            else:
                donneesTestInversees[i] = fct_tri(donneesTestInversees[i])
            time6 = time.time()
            toplotInversees.append(time6 - time5)
    (ok1, ipb1) = sontTries(donneesTestRandom)
    (ok2, ipb2) = sontTries(donneesTestTriees)
    (ok3, ipb3) = sontTries(donneesTestInversees)
    if not ok1:
        print(nom+' donnees random incorrect, liste #' + str(ipb1))
    else:
        plt.plot(axis, toplotRandom, '-'+color, label=nom+' (random)')

    if nom != 'Tri rapide':
        if not ok2:
            print(nom + ' donnees triees incorrect, liste #' + str(ipb2))
        else:
            plt.plot(axis, toplotTriees, '--' + color, label=nom + ' (triees)')
        if not ok3:
            print(nom + ' donnees inversees incorrect, liste #' + str(ipb3))
        else:
            plt.plot(axis, toplotInversees, ':' + color, label=nom + ' (inversees)')


# ========================================================================================
# ========================================================================================
# Tri bulle
def tri_bulle (tab):
    i = len(tab)-1
    while i >= 1:
        for j in range(i):
            if tab[j] > tab[j+1]:
                tab[j], tab[j+1] = tab[j+1], tab[j]
        i = i-1

executerTri(tri_bulle,'r','Tri bulle')

# ========================================================================================
# Tri par insertion
def tri_par_insertion (tab) :
    for j in range(1,len(tab)) :
        elt_a_placer = tab[j]
        i = j-1
        while i >= 0 and tab[i] > elt_a_placer :
            tab[i+1] = tab[i]
            i = i-1
        tab[i+1] = elt_a_placer

executerTri(tri_par_insertion,'b','Tri par insertion')

# ========================================================================================
# Tri par sélection
def tri_par_selection (tab) :
    for i in range(0,len(tab)-1) :    # de 0 à n-2
        indmin = i
        for j in range(i+1,len(tab)) : # de i+1 à n-1, recherche du min
            if tab[j] < tab[indmin] : indmin = j
        tab[indmin],tab[i]=tab[i],tab[indmin]  # echange de valeurs entre indmin et i

executerTri(tri_par_selection,'g','Tri par sélection')

# ========================================================================================
# Tri fusion
def fusion(gauche, droite):
    igauche, idroite = 0,0
    result = []
    while igauche < len(gauche) and idroite < len(droite):
        if gauche[igauche] < droite[idroite]:
            result.append(gauche[igauche])
            igauche += 1
        else:
            result.append(droite[idroite])
            idroite += 1
    result += gauche[igauche:]
    result += droite[idroite:]
    return result

def triFusion (tab):
    if len(tab) <= 1 :
        return tab
    milieu = len(tab) // 2
    gauche = triFusion(tab[:milieu])
    droite = triFusion(tab[milieu:])
    return fusion(gauche,droite)

executerTri(triFusion,'k','Tri fusion',False)

# ========================================================================================
# Tri par base
def nbDigit(n):
    nb = 1
    while n >= 10:
        n = n // 10
        nb += 1
    return nb

def valeurBase(n,i) :
    return (n // (10**i)) % 10

def TriRadix (tab) :
    nbDig = nbDigit(max(tab))
    for digit in range(nbDig):
        cpt = [0] * 10                            # init compteur
        temp = [0] * len(tab)                     # liste résultat itération
        for val in tab:                           # parcours de tab
            cpt[valeurBase(val,digit)] += 1       # compteur clé (unité, dizaine, etc.)
        for i in range(1,10):                     # cumul compteur => position
            cpt[i] += cpt[i-1]
        for i in range(len(tab)-1,-1,-1):         # placement position trié par clé
            indTemp = valeurBase(tab[i],digit)    # indice placement
            temp[cpt[indTemp]-1] = tab[i]         # décalage déplacement (cpt != pos)
            cpt[indTemp] -= 1                     # décrément pos prochain même clé
        tab[:] = temp[:]                          # recopie résultat

executerTri(TriRadix,'y','Tri par base')

# ========================================================================================
# Tri rapide
def partitioner (tab, premier, dernier) :
    j = premier        # décalage/compteur du premier élément inférieur au pivot
    for i in range(premier,dernier) :
        if tab[i] <= tab[dernier] :
            tab[i],tab[j] = tab[j],tab[i]
            j = j + 1
    tab[dernier],tab[j] = tab[j],tab[dernier]
    return j

def triRapideTableau (tab, premier, dernier) :
    if premier < dernier :
        pivot = partitioner(tab,premier,dernier)
        triRapideTableau(tab,premier,pivot-1)
        triRapideTableau(tab,pivot+1,dernier)

def triRapide (tab) :
    triRapideTableau(tab,0,len(tab)-1)

executerTri(triRapide,'c','Tri rapide')

# ========================================================================================
# Tri comptage
def comptage (L,N) :
    P = [0 for i in range(N)]
    for k in L :
        P[k] += 1                 # on incrémente P[k] à chaque occurrence de k
    return P

def triComptage (L) :
    N = max(L)+1
    M = []
    P = comptage(L,N)
    for k in range(N) :
        for i in range(P[k]) :
            M.append(k)
    return M

executerTri(triComptage,'m','Tri comptage',False)

# ========================================================================================
#plt.yscale('log')
plt.grid(True)
plt.legend(loc='upper left')
plt.show()